Index: branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 492)
+++ branches/ODCCP/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 494)
@@ -45,5 +45,5 @@
 #define DEBUG_MEMC_WRITE     1 // detailed trace of WRITE FSM
 #define DEBUG_MEMC_CAS       1 // detailed trace of CAS FSM
-#define DEBUG_MEMC_IXR_CMD   1 // detailed trace of IXR_RSP FSM
+#define DEBUG_MEMC_IXR_CMD   1 // detailed trace of IXR_CMD FSM
 #define DEBUG_MEMC_IXR_RSP   1 // detailed trace of IXR_RSP FSM
 #define DEBUG_MEMC_XRAM_RSP  1 // detailed trace of XRAM_RSP FSM
@@ -127,6 +127,5 @@
   "MULTI_ACK_UPT_LOCK",
   "MULTI_ACK_UPT_CLEAR",
-  "MULTI_ACK_WRITE_RSP",
-  "MULTI_ACK_CONFIG_ACK"
+  "MULTI_ACK_WRITE_RSP"
 };
 const char *config_fsm_str[] =
@@ -134,15 +133,17 @@
   "CONFIG_IDLE",
   "CONFIG_LOOP",
+  "CONFIG_WAIT",
   "CONFIG_RSP",
   "CONFIG_DIR_REQ",
   "CONFIG_DIR_ACCESS",
-  "CONFIG_DIR_IVT_LOCK",
+  "CONFIG_IVT_LOCK",
   "CONFIG_BC_SEND",
-  "CONFIG_BC_WAIT",
-  "CONFIG_INV_SEND",
+  "CONFIG_INVAL_SEND",
   "CONFIG_HEAP_REQ",
   "CONFIG_HEAP_SCAN",
   "CONFIG_HEAP_LAST",
-  "CONFIG_INV_WAIT"
+  "CONFIG_TRT_LOCK",
+  "CONFIG_TRT_SET",
+  "CONFIG_PUT_REQ"
 };
 const char *read_fsm_str[] =
@@ -168,5 +169,4 @@
   "WRITE_DIR_REQ",
   "WRITE_DIR_LOCK",
-  "WRITE_DIR_READ",
   "WRITE_DIR_HIT",
   "WRITE_UPT_LOCK",
@@ -180,4 +180,5 @@
   "WRITE_MISS_TRT_SET",
   "WRITE_MISS_XRAM_REQ",
+  "WRITE_BC_DIR_READ",
   "WRITE_BC_TRT_LOCK",
   "WRITE_BC_IVT_LOCK",
@@ -202,5 +203,5 @@
   "XRAM_RSP_DIR_UPDT",
   "XRAM_RSP_DIR_RSP",
-  "XRAM_RSP_INVAL_LOCK",
+  "XRAM_RSP_IVT_LOCK",
   "XRAM_RSP_INVAL_WAIT",
   "XRAM_RSP_INVAL",
@@ -219,10 +220,17 @@
   "IXR_CMD_XRAM_IDLE",
   "IXR_CMD_CLEANUP_IDLE",
-  "IXR_CMD_TRT_LOCK",
-  "IXR_CMD_READ",
-  "IXR_CMD_WRITE",
-  "IXR_CMD_CAS",
-  "IXR_CMD_XRAM",
-  "IXR_CMD_CLEANUP_DATA"
+  "IXR_CMD_CONFIG_IDLE",
+  "IXR_CMD_READ_TRT",
+  "IXR_CMD_WRITE_TRT",
+  "IXR_CMD_CAS_TRT",
+  "IXR_CMD_XRAM_TRT",
+  "IXR_CMD_CLEANUP_TRT",
+  "IXR_CMD_CONFIG_TRT",
+  "IXR_CMD_READ_SEND",
+  "IXR_CMD_WRITE_SEND",
+  "IXR_CMD_CAS_SEND",
+  "IXR_CMD_XRAM_SEND",
+  "IXR_CMD_CLEANUP_DATA_SEND",
+  "IXR_CMD_CONFIG_SEND"
 };
 const char *cas_fsm_str[] =
@@ -267,5 +275,4 @@
   "CLEANUP_IVT_CLEAR",
   "CLEANUP_WRITE_RSP",
-  "CLEANUP_CONFIG_ACK",
   "CLEANUP_IXR_REQ",
   "CLEANUP_WAIT",
@@ -290,9 +297,9 @@
   "ALLOC_TRT_IXR_RSP",
   "ALLOC_TRT_CLEANUP",
-  "ALLOC_TRT_IXR_CMD"
+  "ALLOC_TRT_IXR_CMD",
+  "ALLOC_TRT_CONFIG"
 };
 const char *alloc_upt_fsm_str[] =
 {
-  "ALLOC_UPT_CONFIG",
   "ALLOC_UPT_WRITE",
   "ALLOC_UPT_CAS",
@@ -351,5 +358,5 @@
   : soclib::caba::BaseModule(name),
 
-    m_monitor_ok(false),
+    //m_monitor_ok(false),
     
     p_clk( "p_clk" ),
@@ -394,5 +401,4 @@
     m_broadcast_boundaries(0x7C1F),
 
-    r_tgt_cmd_fsm("r_tgt_cmd_fsm"),
 
     //  FIFOs
@@ -421,4 +427,6 @@
     m_cc_receive_to_multi_ack_fifo("m_cc_receive_to_multi_ack_fifo", 4),
 
+    r_tgt_cmd_fsm("r_tgt_cmd_fsm"),
+
     r_config_fsm( "r_config_fsm" ),
 
@@ -432,7 +440,4 @@
     m_write_to_cc_send_inst_fifo("m_write_to_cc_send_inst_fifo",8),
     m_write_to_cc_send_srcid_fifo("m_write_to_cc_send_srcid_fifo",8),
-#if L1_MULTI_CACHE
-    m_write_to_cc_send_cache_id_fifo("m_write_to_cc_send_cache_id_fifo",8),
-#endif
 
     r_multi_ack_fsm("r_multi_ack_fsm"),
@@ -444,7 +449,4 @@
     m_cas_to_cc_send_inst_fifo("m_cas_to_cc_send_inst_fifo",8),
     m_cas_to_cc_send_srcid_fifo("m_cas_to_cc_send_srcid_fifo",8),
-#if L1_MULTI_CACHE
-    m_cas_to_cc_send_cache_id_fifo("m_cas_to_cc_send_cache_id_fifo",8),
-#endif
 
     r_ixr_rsp_fsm("r_ixr_rsp_fsm"),
@@ -453,7 +455,4 @@
     m_xram_rsp_to_cc_send_inst_fifo("m_xram_rsp_to_cc_send_inst_fifo",8),
     m_xram_rsp_to_cc_send_srcid_fifo("m_xram_rsp_to_cc_send_srcid_fifo",8),
-#if L1_MULTI_CACHE
-    m_xram_rsp_to_cc_send_cache_id_fifo("m_xram_rsp_to_cc_send_cache_id_fifo",8),
-#endif
 
     r_ixr_cmd_fsm("r_ixr_cmd_fsm"),
@@ -524,5 +523,4 @@
     r_xram_rsp_victim_data     = new sc_signal<data_t>[nwords];
     r_xram_rsp_to_tgt_rsp_data = new sc_signal<data_t>[nwords];
-    r_xram_rsp_to_ixr_cmd_data = new sc_signal<data_t>[nwords];
 
     // Allocation for READ FSM
@@ -535,8 +533,6 @@
     r_write_to_cc_send_data    = new sc_signal<data_t>[nwords];
     r_write_to_cc_send_be      = new sc_signal<be_t>[nwords];
-    r_write_to_ixr_cmd_data    = new sc_signal<data_t>[nwords];
 
     // Allocation for CAS FSM
-    r_cas_to_ixr_cmd_data      = new sc_signal<data_t>[nwords];
     r_cas_data                 = new sc_signal<data_t>[nwords];
     r_cas_rdata                = new sc_signal<data_t>[2];
@@ -544,10 +540,12 @@
     // Allocation for ODCCP
     r_cleanup_data             = new sc_signal<data_t>[nwords];
-    r_ixr_cmd_data             = new sc_signal<data_t>[nwords];
     r_cleanup_to_ixr_cmd_data  = new sc_signal<data_t>[nwords];
 
+    // Allocation for IXR_CMD FSM
+    r_ixr_cmd_wdata            = new sc_signal<data_t>[nwords];
+
     // Allocation for debug
-    m_debug_previous_data      = new sc_signal<data_t>[nwords];
-    m_debug_data               = new sc_signal<data_t>[nwords];
+    m_debug_previous_data      = new data_t[nwords];
+    m_debug_data               = new data_t[nwords];
 
     SC_METHOD(transition);
@@ -560,36 +558,4 @@
 } // end constructor
 
-///////////////////////////////////////////////////////////////////////
-tmpl(void) ::start_monitor(addr_t addr, addr_t length)
-///////////////////////////////////////////////////////////////////////
-{
-  m_monitor_ok        = true;
-  m_monitor_base      = addr;
-  m_monitor_length    = length;
-}
-
-///////////////////////////////////////////////////////////////////////
-tmpl(void) ::stop_monitor()
-///////////////////////////////////////////////////////////////////////
-{
-  m_monitor_ok        = false;
-}
-
-////////////////////////////////////////////////
-tmpl(void) ::check_monitor( addr_t      addr,
-                            data_t      data,
-                            bool        read )
-////////////////////////////////////////////////
-{
-  if((addr >= m_monitor_base) and
-      (addr < m_monitor_base + m_monitor_length))
-  {
-    if ( read ) std::cout << " Monitor MEMC Read ";
-    else        std::cout << " Monitor MEMC Write";
-    std::cout << " / Address = " << std::hex << addr
-              << " / Data = " << data
-              << " at cycle " << std::dec << m_cpt_cycles << std::endl;
-  }
-}
 
 /////////////////////////////////////////////////////
@@ -601,19 +567,20 @@
     DirectoryEntry entry = m_cache_directory.read_neutral(addr, &way, &set );
 
+    // read data and compute data_change
     bool data_change = false;
-
     if ( entry.valid )
     {
-        m_cache_data.read_line( way, set, m_debug_data );
-
-        for ( size_t i = 0 ; i<m_words ; i++ )
-        {
-            if ( m_debug_previous_valid and
-                 (m_debug_data[i].read() != m_debug_previous_data[i].read()) )
-                 data_change = true;
-            m_debug_previous_data[i] = m_debug_data[i].read();
+        for ( size_t word = 0 ; word<m_words ; word++ )
+        {
+            m_debug_data[word] = m_cache_data.read(way, set, word);
+            if ( m_debug_previous_valid and 
+                 (m_debug_data[word] != m_debug_previous_data[word]) )
+            {
+                data_change = true;
+            }
         }
     }
     
+    // print values if any change
     if ( (entry.valid != m_debug_previous_valid) or
          (entry.valid and (entry.count != m_debug_previous_count)) or
@@ -623,14 +590,35 @@
                   << " at cycle " << std::dec << m_cpt_cycles
                   << " for address " << std::hex << addr
-                  << " / HIT = " << std::dec << entry.valid
+                  << " / VAL = " << std::dec << entry.valid
                   << " / WAY = " << way
                   << " / COUNT = " << entry.count 
                   << " / DIRTY = " << entry.dirty
-                  << " / DATA_CHANGE = " << entry.count 
+                  << " / DATA_CHANGE = " << data_change 
                   << std::endl;
-    }
+        std::cout << std::hex << "     /0:" << m_debug_data[0]
+                  << "/1:" << m_debug_data[1]
+                  << "/2:" << m_debug_data[2]
+                  << "/3:" << m_debug_data[3]
+                  << "/4:" << m_debug_data[4]
+                  << "/5:" << m_debug_data[5]
+                  << "/6:" << m_debug_data[6]
+                  << "/7:" << m_debug_data[7]
+                  << "/8:" << m_debug_data[8]
+                  << "/9:" << m_debug_data[9]
+                  << "/A:" << m_debug_data[10]
+                  << "/B:" << m_debug_data[11]
+                  << "/C:" << m_debug_data[12]
+                  << "/D:" << m_debug_data[13]
+                  << "/E:" << m_debug_data[14]
+                  << "/F:" << m_debug_data[15]
+                  << std::endl;
+    }
+
+    // register values
     m_debug_previous_count = entry.count;
     m_debug_previous_valid = entry.valid;
     m_debug_previous_dirty = entry.dirty;
+    for( size_t word=0 ; word<m_words ; word++ ) 
+        m_debug_previous_data[word] = m_debug_data[word];
 }
 
@@ -807,5 +795,4 @@
   delete [] r_xram_rsp_victim_data;
   delete [] r_xram_rsp_to_tgt_rsp_data;
-  delete [] r_xram_rsp_to_ixr_cmd_data;
 
   delete [] r_read_data;
@@ -889,7 +876,4 @@
     m_config_to_cc_send_inst_fifo.init();
     m_config_to_cc_send_srcid_fifo.init();
-#if L1_MULTI_CACHE
-    m_config_to_cc_send_cache_id_fifo.init();
-#endif
 
     r_tgt_cmd_to_tgt_rsp_req = false;
@@ -906,7 +890,4 @@
     m_write_to_cc_send_inst_fifo.init();
     m_write_to_cc_send_srcid_fifo.init();
-#if L1_MULTI_CACHE
-    m_write_to_cc_send_cache_id_fifo.init();
-#endif
 
     r_cleanup_to_tgt_rsp_req      = false;
@@ -914,5 +895,5 @@
     m_cc_receive_to_cleanup_fifo.init();
 
-    r_multi_ack_to_tgt_rsp_req     = false;
+    r_multi_ack_to_tgt_rsp_req    = false;
 
     m_cc_receive_to_multi_ack_fifo.init();
@@ -922,12 +903,9 @@
     r_cas_lfsr                    = -1   ;
     r_cas_to_ixr_cmd_req          = false;
-    r_cas_to_cc_send_multi_req   = false;
-    r_cas_to_cc_send_brdcast_req = false;
+    r_cas_to_cc_send_multi_req    = false;
+    r_cas_to_cc_send_brdcast_req  = false;
 
     m_cas_to_cc_send_inst_fifo.init();
     m_cas_to_cc_send_srcid_fifo.init();
-#if L1_MULTI_CACHE
-    m_cas_to_cc_send_cache_id_fifo.init();
-#endif
 
     for(size_t i=0; i<m_trt_lines ; i++)
@@ -945,9 +923,5 @@
     m_xram_rsp_to_cc_send_inst_fifo.init();
     m_xram_rsp_to_cc_send_srcid_fifo.init();
-#if L1_MULTI_CACHE
-    m_xram_rsp_to_cc_send_cache_id_fifo.init();
-#endif
-
-    r_ixr_cmd_cpt          = 0;
+
     r_alloc_dir_reset_cpt  = 0;
     r_alloc_heap_reset_cpt = 0;
@@ -964,5 +938,5 @@
     //r_xram_rsp_to_ixr_cmd_inval_ncc_pending = false;
     r_cleanup_to_ixr_cmd_srcid = 0;
-    r_cleanup_to_ixr_cmd_trdid = 0;
+    r_cleanup_to_ixr_cmd_index = 0;
     r_cleanup_to_ixr_cmd_pktid = 0;
     r_cleanup_to_ixr_cmd_nline = 0;
@@ -971,5 +945,5 @@
       r_cleanup_to_ixr_cmd_data[word] = 0;
       r_cleanup_data[word] = 0;
-      r_ixr_cmd_data[word] = 0;
+      r_ixr_cmd_wdata[word] = 0;
     }
 
@@ -1053,8 +1027,4 @@
   size_t  write_to_cc_send_fifo_srcid = 0;
 
-#if L1_MULTI_CACHE
-  size_t  write_to_cc_send_fifo_cache_id = 0;
-#endif
-
   bool    xram_rsp_to_cc_send_fifo_put   = false;
   bool    xram_rsp_to_cc_send_fifo_get   = false;
@@ -1062,8 +1032,4 @@
   size_t  xram_rsp_to_cc_send_fifo_srcid = 0;
 
-#if L1_MULTI_CACHE
-  size_t  xram_rsp_to_cc_send_fifo_cache_id = 0;
-#endif
-
   bool    config_to_cc_send_fifo_put   = false;
   bool    config_to_cc_send_fifo_get   = false;
@@ -1075,8 +1041,4 @@
   bool    cas_to_cc_send_fifo_inst  = false;
   size_t  cas_to_cc_send_fifo_srcid = 0;
-
-#if L1_MULTI_CACHE
-  size_t  cas_to_cc_send_fifo_cache_id = 0;
-#endif
 
   m_debug = (m_cpt_cycles > m_debug_start_cycle) and m_debug_ok;
@@ -1129,4 +1091,6 @@
   // - For MEMC_CMD_TYPE, the response is delayed until the operation is completed.
   ////////////////////////////////////////////////////////////////////////////////////
+
+//std::cout << std::endl << "tgt_cmd_fsm" << std::endl;
 
   switch(r_tgt_cmd_fsm.read())
@@ -1232,5 +1196,5 @@
     case TGT_CMD_ERROR:  // response error must be sent
 
-    // wait if pending TGT_CMD request to TGT_RSP FSM
+    // wait if pending request
     if(r_tgt_cmd_to_tgt_rsp_req.read()) break;
 
@@ -1266,4 +1230,5 @@
         size_t   error;  
         uint32_t rdata = 0;         // default value
+        uint32_t wdata = p_vci_tgt.wdata.read();
 
         if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_READ)         // get lock
@@ -1274,7 +1239,14 @@
             error            = 0;
             r_config_lock    = true;
+            if ( rdata == 0 )
+            {
+                r_tgt_cmd_srcid = p_vci_tgt.srcid.read();
+                r_tgt_cmd_trdid = p_vci_tgt.trdid.read();
+                r_tgt_cmd_pktid = p_vci_tgt.pktid.read();
+            }
         }
         else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)  // release lock
-                   and (cell == MEMC_LOCK) )
+                   and (cell == MEMC_LOCK)
+                   and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
         {
             need_rsp         = true;
@@ -1283,6 +1255,10 @@
         }
         else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set addr_lo
-                   and (cell == MEMC_ADDR_LO) )
-        {
+                   and (cell == MEMC_ADDR_LO)
+                   and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
+        {
+            assert( ((wdata % (m_words*vci_param_int::B)) == 0) and
+            "VCI_MEM_CACHE CONFIG ERROR: The buffer must be aligned on a cache line");
+
             need_rsp         = true;
             error            = 0;
@@ -1291,5 +1267,7 @@
         }
         else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set addr_hi
-                   and (cell == MEMC_ADDR_HI) )
+                   and (cell == MEMC_ADDR_HI)
+                   and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
+
         {
             need_rsp         = true;
@@ -1299,18 +1277,23 @@
         }
         else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set buf_lines
-                   and (cell == MEMC_BUF_LENGTH) )
+                   and (cell == MEMC_BUF_LENGTH)
+                   and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
         {
             need_rsp         = true;
             error            = 0;
             size_t lines = (size_t)(p_vci_tgt.wdata.read()/(m_words<<2));
-            if ( r_config_address.read()/(m_words*vci_param_int::B) ) lines++;
-            r_config_nlines  = lines;
+            if ( r_config_address.read()%(m_words*4) ) lines++;
+            r_config_cmd_lines  = lines;
+            r_config_rsp_lines  = lines;
         }
         else if ( (p_vci_tgt.cmd.read() == vci_param_int::CMD_WRITE)   // set cmd type
-                   and (cell == MEMC_CMD_TYPE) )
+                   and (cell == MEMC_CMD_TYPE)
+                   and (p_vci_tgt.srcid.read() == r_tgt_cmd_srcid.read()) )
         {
             need_rsp         = false;
             error            = 0;
             r_config_cmd     = p_vci_tgt.wdata.read();
+
+            // prepare delayed response from CONFIG FSM
             r_config_srcid   = p_vci_tgt.srcid.read();
             r_config_trdid   = p_vci_tgt.trdid.read();
@@ -1343,4 +1326,5 @@
           << " address = " << std::hex << p_vci_tgt.address.read()
           << " / wdata = " << p_vci_tgt.wdata.read()
+          << " / need_rsp = " << need_rsp
           << " / error = " << error << std::endl;
 #endif
@@ -1446,7 +1430,6 @@
   //    MULTI_ACK FSM
   /////////////////////////////////////////////////////////////////////////
-  // This FSM controls the response to the multicast update or multicast
-  // inval coherence requests sent by the memory cache to the L1 caches and
-  // update the UPT.
+  // This FSM controls the response to the multicast update requests sent 
+  // by the memory cache to the L1 caches and update the UPT.
   //
   // - The FSM decrements the proper entry in UPT,
@@ -1454,10 +1437,10 @@
   // - If required, it sends a request to the TGT_RSP FSM to complete
   //   a pending  write transaction.
-  // - If required, it sends an acknowledge to the CONFIG FSM to signal 
-  //   completion of a line inval.
   //
   // All those multi-ack packets are one flit packet.
-  // The index in the UPT is defined in the UPDTID field.
+  // The index in the UPT is defined in the TRDID field.
   ////////////////////////////////////////////////////////////////////////
+
+//std::cout << std::endl << "multi_ack_fsm" << std::endl;
 
   switch(r_multi_ack_fsm.read())
@@ -1574,5 +1557,4 @@
         r_multi_ack_nline = m_upt.nline(r_multi_ack_upt_index.read());
         bool need_rsp     = m_upt.need_rsp(r_multi_ack_upt_index.read());
-        bool need_ack     = m_upt.need_ack(r_multi_ack_upt_index.read());
 
         // clear the UPT entry
@@ -1580,5 +1562,4 @@
 
         if      ( need_rsp ) r_multi_ack_fsm = MULTI_ACK_WRITE_RSP;
-        else if ( need_ack ) r_multi_ack_fsm = MULTI_ACK_CONFIG_ACK;
         else                 r_multi_ack_fsm = MULTI_ACK_IDLE;
 
@@ -1611,20 +1592,4 @@
         break;
     }
-    //////////////////////////
-    case MULTI_ACK_CONFIG_ACK:    // Signals multi-inval completion to CONFIG FSM
-                                  // Wait if pending request 
-    {
-        if ( r_multi_ack_to_config_ack.read() ) break;
-
-        r_multi_ack_to_config_ack   = true;
-        r_multi_ack_fsm              = MULTI_ACK_IDLE;
-
-#if DEBUG_MEMC_MULTI_ACK
-if(m_debug)
-std::cout << "  <MEMC " << name() << " MULTI_ACK_CONFIG_ACK>"
-          << " Signals inval completion to CONFIG FSM" << std::endl;
-#endif
-        break;
-    }
   } // end switch r_multi_ack_fsm
 
@@ -1634,29 +1599,42 @@
   // The CONFIG FSM handles the VCI configuration requests (INVAL & SYNC).
   // The target buffer can have any size, and there is one single command for
-  // all cache lines covered by the target buffer. 
-  // An INVAL or SYNC configuration request is defined by the followinf registers:
-  // - bool      r_config_cmd        : INVAL / SYNC / NOP)
+  // all cache lines covered by the target buffer.
+  //
+  // An INVAL or SYNC configuration operation is defined by the following registers:
+  // - bool      r_config_cmd        : INVAL / SYNC / NOP
   // - uint64_t  r_config_address    : buffer base address
-  // - uint32_t  r_config_nlines     : number of lines covering buffer
+  // - uint32_t  r_config_cmd_lines  : number of lines to be handled
+  // - uint32_t  r_config_rsp_lines  : number of lines not completed
   //
   // For both INVAL and SYNC commands, the CONFIG FSM contains the loop handling 
-  // all cache lines covered by the target buffer.
-  //
+  // all cache lines covered by the buffer. The various lines of a given buffer
+  // can be pipelined: the CONFIG FSM does not wait the response for line (n) to send
+  // the command for line (n+1). It decrements the r_config_cmd_lines counter until 
+  // the last request has been registered in TRT (for a SYNC), or in IVT (for an INVAL).
+  // 
   // - INVAL request:
-  //   For each line, it access to the DIR array. 
+  //   For each line, it access to the DIR. 
   //   In case of miss, it does nothing, and a response is requested to TGT_RSP FSM. 
   //   In case of hit, with no copies in L1 caches, the line is invalidated and
   //   a response is requested to TGT_RSP FSM.
   //   If there is copies, a multi-inval, or a broadcast-inval coherence transaction
-  //   is launched and registered in UPT. The multi-inval transaction is signaled
-  //   by the r_multi_ack_to config_ack or r_cleanup_to_config_ack flip-flops.
-  //   The config inval response is sent only when the last line has been invalidated.
-  //
+  //   is launched and registered in UPT. The multi-inval transaction completion
+  //   is signaled by the CLEANUP FSM by decrementing the r_config_rsp_lines counter.
+  //   The CONFIG INVAL response is sent only when the last line has been invalidated.
+  //   TODO : The target buffer address must be aligned on a cache line boundary.
+  //   This constraint can be released, but it requires to make 2 PUT transactions
+  //   for the first and the last line...
+  // 
   // - SYNC request:
-  //
-  //  ...  Not implemented yet ...
+  //   For each line, it access to the DIR. 
+  //   In case of miss, it does nothing, and a response is requested to TGT_RSP FSM. 
+  //   In case of hit, a PUT transaction is registered in TRT and a request is sent
+  //   to IXR_CMD FSM. The IXR_RSP FSM decrements the r_config_rsp_lines counter
+  //   when a PUT response is received.
+  //   The CONFIG SYNC response is sent only when the last PUT response is received.
   //
   // From the software point of view, a configuration request is a sequence
-  // of 6 atomic accesses in an uncached segment:
+  // of 6 atomic accesses in an uncached segment. A dedicated lock is used 
+  // to handle only one configuration command at a given time:
   // - Read  MEMC_LOCK       : Get the lock
   // - Write MEMC_ADDR_LO    : Set the buffer address LSB
@@ -1667,4 +1645,6 @@
   ////////////////////////////////////////////////////////////////////////////////////
 
+//std::cout << std::endl << "config_fsm" << std::endl;
+
   switch( r_config_fsm.read() )
   {
@@ -1679,6 +1659,6 @@
 if(m_debug)
 std::cout << "  <MEMC " << name() << " CONFIG_IDLE> Config Request received" 
-          << " address = " << std::hex << r_config_address.read()
-          << " / nlines = " << std::dec << r_config_nlines.read()
+          << " / address = " << std::hex << r_config_address.read()
+          << " / lines = " << std::dec << r_config_cmd_lines.read()
           << " / type = " << r_config_cmd.read() << std::endl;
 #endif
@@ -1687,10 +1667,10 @@
       }
       /////////////////
-      case CONFIG_LOOP:   // test last line 
-      {
-          if ( r_config_nlines.read() == 0 )
+      case CONFIG_LOOP:   // test if last line to be handled
+      {
+          if ( r_config_cmd_lines.read() == 0 )
           {
               r_config_cmd = MEMC_CMD_NOP;
-              r_config_fsm = CONFIG_RSP;
+              r_config_fsm = CONFIG_WAIT;
           }
           else
@@ -1702,9 +1682,48 @@
 if(m_debug)
 std::cout << "  <MEMC " << name() << " CONFIG_LOOP>" 
-          << " address = " << std::hex << r_config_address.read()    
-          << " / nlines = " << std::dec << r_config_nlines.read() 
+          << " / address = " << std::hex << r_config_address.read()    
+          << " / lines not handled = " << std::dec << r_config_cmd_lines.read() 
           << " / command = " << r_config_cmd.read() << std::endl;
 #endif
           break;
+      }
+      /////////////////
+      case CONFIG_WAIT:   // wait completion (last response) 
+      {
+          if ( r_config_rsp_lines.read() == 0 )  // last response received
+          {
+              r_config_fsm = CONFIG_RSP;
+          }
+
+#if DEBUG_MEMC_CONFIG
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CONFIG_WAIT>" 
+          << " / lines to do = " << std::dec << r_config_rsp_lines.read() << std::endl;
+#endif
+          break;
+      }
+      ////////////////
+      case CONFIG_RSP:  // request TGT_RSP FSM to return response 
+      {
+          if ( not r_config_to_tgt_rsp_req.read() )
+          {
+              r_config_to_tgt_rsp_srcid  = r_config_srcid.read();
+              r_config_to_tgt_rsp_trdid  = r_config_trdid.read();
+              r_config_to_tgt_rsp_pktid  = r_config_pktid.read();
+              r_config_to_tgt_rsp_error  = false;
+              r_config_to_tgt_rsp_req    = true;
+              r_config_fsm               = CONFIG_IDLE;
+
+#if DEBUG_MEMC_CONFIG
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CONFIG_RSP> Request TGT_RSP FSM to return response:"
+          << " error = " << r_config_to_tgt_rsp_error.read()
+          << " / rsrcid = " << std::hex << r_config_srcid.read()
+          << " / rtrdid = " << std::hex << r_config_trdid.read()
+          << " / rpktid = " << std::hex << r_config_pktid.read() << std::endl;
+#endif
+          }
+          break;
+
       }
       ////////////////////
@@ -1726,4 +1745,7 @@
       case CONFIG_DIR_ACCESS:   // Access directory and decode config command
       {
+          assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CONFIG) and
+          "MEMC ERROR in CONFIG_DIR_ACCESS state: bad DIR allocation");
+
           size_t way = 0;
           DirectoryEntry entry = m_cache_directory.read(r_config_address.read(), way);
@@ -1736,8 +1758,9 @@
               r_config_dir_copy_srcid = entry.owner.srcid;
               r_config_dir_is_cnt     = entry.is_cnt;
+              r_config_dir_lock       = entry.lock;
               r_config_dir_count      = entry.count;
-              r_config_dir_next_ptr   = entry.ptr;
-
-              r_config_fsm    = CONFIG_DIR_IVT_LOCK;
+              r_config_dir_ptr        = entry.ptr;
+
+              r_config_fsm    = CONFIG_IVT_LOCK;
           }
           else if ( entry.valid and                       // hit & sync command
@@ -1745,13 +1768,13 @@
                     (r_config_cmd.read() == MEMC_CMD_SYNC) )
           { 
-              std::cout << "VCI_MEM_CACHE ERROR: "
-                        << "SYNC config request not implemented yet" << std::endl;
-              exit(0);
+              r_config_fsm  = CONFIG_TRT_LOCK;
           }
-          else                                            // return to LOOP 
+          else                                            // miss : return to LOOP 
           {
-              r_config_nlines  = r_config_nlines.read() - 1;
-              r_config_address = r_config_address.read() + (m_words<<2);
-              r_config_fsm     = CONFIG_LOOP;
+              r_config_cmd_lines = r_config_cmd_lines.read() - 1;
+              r_config_rsp_lines = r_config_rsp_lines.read() - 1;
+              r_config_cmd_lines = r_config_cmd_lines.read() - 1;
+              r_config_address   = r_config_address.read() + (m_words<<2);
+              r_config_fsm       = CONFIG_LOOP;
           }
 
